'Allegro.Bas    Grundgeruest um Allegro in Freebasic einzubinden
'===============================================================
'Initialisierungsbereich
'---------------------------------------------------------------
TYPE Bildschirme
   Breite AS INTEGER
   Hoehe  AS INTEGER
   Tiefe  AS INTEGER
END TYPE
TYPE FensterDaten
   BmpPointer   AS ANY PTR
   HgBmpBildNr  AS INTEGER
   HgBmpBildBreit  AS INTEGER
   HgBmpBildHoch   AS INTEGER
   Titel        AS STRING * 40
   VerbergeTitel AS INTEGER
   XPos         AS INTEGER
   YPos         AS INTEGER
   Breite       AS INTEGER
   Hoehe        AS INTEGER
   GrundFarbR   AS INTEGER
   GrundFarbG   AS INTEGER
   GrundFarbB   AS INTEGER
   GrundFarbRGB AS UNSIGNED INTEGER
   NextAktionFarbe AS UNSIGNED INTEGER
   RahmFarbR    AS INTEGER
   RahmFarbG    AS INTEGER
   RahmFarbB    AS INTEGER
   RahmFarbRGB  AS UNSIGNED INTEGER
   RahmBreit    AS INTEGER
   RahmAbsVert  AS INTEGER
   RahmAbsHor   AS INTEGER
   SchriftFarbR AS INTEGER
   SchriftFarbG    AS INTEGER
   SchriftFarbB    AS INTEGER
   SchriftFarbRGB  AS UNSIGNED INTEGER
   FontNr       AS INTEGER
   InitFlag     AS INTEGER
   Sichtbar     AS INTEGER
   BildPtr(20)  AS ANY PTR
   MBildBreite(20) AS INTEGER
   MBildHoehe(20) AS INTEGER
   BildZahl     AS INTEGER
END TYPE

'---------------------------------------------------------------
DECLARE SUB TEXT_Zentriert(AnzeigeText AS STRING, TextFarbNr AS INTEGER)
DECLARE SUB TextOut_Centre(Ziel AS INTEGER, Font AS INTEGER, Text AS STRING, ZeigTxtPosX AS INTEGER, ZeigTxtPosY AS INTEGER, Farbe AS INTEGER)
DECLARE SUB HolDesktopInfo
DECLARE SUB SetzDesktopWieInfo
DECLARE SUB Protokoll(ProtTxt AS STRING)
DECLARE SUB LcdFeld(LcdTxt AS STRING, LcdX AS INTEGER, LcdY AS INTEGER, LcdColor AS UINTEGER, LcdColorB AS UINTEGER, LcdFont AS INTEGER)
DECLARE FUNCTION FragDezWertAb (DezAnzeigeText AS STRING) AS STRING
DECLARE FUNCTION FragZahlen () AS STRING
DECLARE FUNCTION readkey () AS STRING
DECLARE FUNCTION text_height (font AS INTEGER) AS INTEGER
DECLARE FUNCTION ZufallsZahlen (first AS INTEGER, last AS INTEGER) AS INTEGER
DECLARE SUB LassBildAufloesungWaehlen()
'---------------------------------------------------------------
DIM SHARED AS INTEGER ZeilenYPos, Erfolg, ReturnWert, SchleifenZahl, TextZentriertZeile, Protokollieren
DIM SHARED AS INTEGER HgBildBreite, HgBildHoehe, HgAnzeigeBreite, HgAnzeigeHoehe, KopfFensterHoehe, FensterUntenHoehe, HilfefensterNr, HilfeFensterZahl
DIM SHARED AS INTEGER font, VarScreen, FbGfxBreite, FbGfxHoehe, FbGfxTiefe
DIM SHARED AS INTEGER FigurNr, VarScreen_W, VarScreen_H, VarScreen_T
DIM SHARED AS INTEGER Zaehler, tempY, tempX, TempStep, TempMitte, TempHoehe
DIM AS STRING Taste, Dummy, FigurNameHpt
DIM SHARED AS STRING KopfZeile, VZT, FmodEinbinden
DIM SHARED AS STRING Hintergrundbildname
DIM SHARED AS INTEGER MaxFigur, AktiveFigur, LinkerLaufRand, RechterLaufRand,ObererLaufRand, UntererLaufRand
DIM SHARED AS INTEGER DateiExistiert, BildFrequenzZeit, Statistiktimer, StatistikTimeZahl, ZeigLaufNummer, ZeigKollision
DIM SHARED AS DOUBLE GesRepSecs, GesMaxRepSecs, GesLTimer, StatistikTimeSchnitt, LetztStatistiktimer
DIM SHARED AS ANY PTR Hintergrundbildpointer, HintergrundGesamtPointer
DIM SHARED FontArray( 0 TO 2, 0 TO 255, 0 TO 32) AS INTEGER :'Platz fr 2 verschiedene Fonts
DIM SHARED FontHoehe AS INTEGER, FontBreite AS INTEGER' das sind wichtige Variablen und sollten immer und berall greifbar sein
DIM SHARED Fen(50) AS FensterDaten
DIM SHARED FmodOKFlag AS INTEGER
DIM SHARED AS INTEGER MausX, MausY, MausButt, MausRes, MausFlag
DIM SHARED AS INTEGER DesktopBreite, DesktopHoehe, DesktopFarbTiefe
DIM SHARED AS STRING DesktopDriverName
HolDesktopInfo 'um nach Programmende wieder auf Desktopeinstellungen zurck zu schalten (fr linux)
VZT = "/" : ' Trenner fr Verzeichnisnamen in Dateinamen, unter Win und Dos "\" unter Linux "/"
#ifdef __FB_WIN32__
  VZT = "\"
  FmodEinbinden = "ja"
#endif
#ifdef __FB_LINUX__
  VZT = "/"
  FmodEinbinden = "ja"
#endif
#ifdef __FB_DOS__
  VZT = "\"
  FmodEinbinden = "nein"
#endif

KopfZeile="FIGUREN.BAS  V 0.1               Eastler              23.Januar bis 30.Juni 2008" & CHR$(10) + STRING(80,"-")
KopfFensterHoehe=44
FensterUntenHoehe=100
HilfeFensterZahl = 3
font=0
VarScreen=0
MaxFigur=10
Protokollieren=0

'Andere Subs Functions dazuladen
'---------------------------------------------------------------
' HINWEIS ZU INCLUDES: In #include-Zeilen knnen keine Variablen verwendet werden
'         ABER: Verzeichnisseparatoren (/ \) werden von FB hier autom. angepat,
'               also keine Notwendigkeit, hier mit der Var VZT sich auf Dos oder Linux einzustellen
#include "fbgfx.bi"
#include once "vbcompat.bi"        'Damit der Befehl Format fr formatierte Zahlenausgabe vorhanden ist (TimerWerte)
#include once "sub/schrift.bas"   '' das sind die Progr-Zeilen, die fr Texte Anzeigen zustndig sind
SetFont
FontHoehe=GibFontHoehe(0):FontBreite=GibFontBreite(0)
#include once "sub/objekte.bas"    '' das sind die Progr-Zeilen, die die Objekte steuern
#include once "sub/figure.bas"    '' das sind die Progr-Zeilen, die die Figuren steuern
#include once "sub/fenster.bas"   '' das sind die Progr-Zeilen, die fr Anzeigebereiche zustndig sind
#include once "sub/fensterd.bas"   '' das sind die Progr-Zeilen, die fr Anzeigebereiche zustndig sind
#ifdef __FB_DOS__
#include once "sub/fmodleer.bas"   '' das sind die Progr-Zeilen, die fr Sound und Musik zustndig sind. Nicht unter Dos einbinden
#else
#include once "sub/fmod.bas"   '' das sind die Progr-Zeilen, die fr Sound und Musik zustndig sind. Nicht unter Dos einbinden
#endif
#include once "sub/bilder.bas"   '' das sind die Progr-Zeilen, die fr Sound und Musik zustndig sind
'#include once "sub/kacheln.bas"    '' das sind die Progr-Zeilen, die die Bodenkacheln steuern
'===============================================================
'Hauptteil
'---------------------------------------------------------------
On Error Goto Fehler
LassBildAufloesungWaehlen
'Dummy=readkey()

Taste=""
FigurNr=1
AktiveFigur=1


DO UNTIL SchleifenZahl >= 100
      '-------MAUS-AUSWERTEN-UND-GGF-TASTENDRUCK_SIMULIEREN--------
      IF MausFlag = 1 THEN SLEEP 99 : SLEEP 99 : SLEEP 99 : MausFlag = 0
      MausRes = GETMOUSE ( MausX, MausY, , MausButt )
      IF MausRes = 0 THEN
      'nur wenn Maus im Fenster ist prfen
         IF(MausButt AND 1) THEN
        'nur bei linkem Mausklick
              'je nach dem, welches Hilfefenster grad angezeigt wird,
              'dasjenige fragen, ob maus pat
              SELECT CASE HilfefensterNr
                 CASE 0 : Taste=AnzeigeFensterUnten("Mausklick")
                 CASE 1 : Taste=AnzeigeHilfe1("Mausklick")
                 CASE 2 : Taste=AnzeigeHilfe2("Mausklick")
                 CASE 3 : Taste=AnzeigeHilfe3("Mausklick")
              END SELECT
            IF Taste="" THEN
            'falls Klick nicht auf Hilfefenster war, dann Figuren prfen
            Figur("LinksKlick", 0, 0, 0, "")
            END IF
         DO UNTIL (MausButt AND 1) <> 1
            'Da ein Klick manchmal bis ins nchste Hilfefenster reicht,
            'einfach nach einem Klick warten, bis die Maustaste
            'losgelassen wurde
            MausRes = GETMOUSE ( MausX, MausY, , MausButt )
         LOOP
         END IF
         IF(MausButt AND 2) THEN
            'rechter Mausklick
               'Bei Rechtsklick Laufrichtung der grad aktiven Figur in Abhnigkeit der Mausposition ndern
                IF MausX >= FG(AktiveFigur).ZPosX + FG(AktiveFigur).FrameBreit THEN
                  '(nach rechts)
                   IF MausY >= FG(AktiveFigur).ZPosY + FG(AktiveFigur).FrameHoch THEN Taste="3" :'(rechts runter)
                   IF MausY <= FG(AktiveFigur).ZPosY THEN  Taste="9" : '(rechts rauf)
                ELSEIF MausX <= FG(AktiveFigur).ZPosX THEN
                  '(nach links)
                   IF MausY >= FG(AktiveFigur).ZPosY + FG(AktiveFigur).FrameHoch THEN Taste="1" :'(links runter)
                   IF MausY <= FG(AktiveFigur).ZPosY THEN Taste="7" :'(links rauf)
                END IF
         END IF
      END IF
      '--------------------------------------------------------
      ' Falls keine Taste gedrckt (auch kein Mausklick) Figuren bewegen
      '--------------------------------------------------------
   IF Taste = "" THEN
         Figur("LaufEinSchritt", 1, 200, 200, FigurNameHpt)
         IF FmodOKFlag  > 0 THEN Dummy = Musik ( "MusikAbspielen", "", 0) :' Falls Lied zu ende, zufaellig nechstes spielen
   ELSE
      '--------------------------------------------------------
      ' Falls Taste (oder ein Mausklick) dann das auswerten
      '--------------------------------------------------------
      SELECT CASE Taste
         CASE CHR(255)&"k" : ' Fenster Schliessen-Button geklickt unter Windows
              'SchleifenZahl = 101 : ' Bei Escape oder Fensterschliessen von Windows aus abbrechen<br>
              'WIE ESCAPE BEHANDELN
              Taste = CHR(27) 'WIRKT NICHT :-(
         CASE CHR(27) : ' ESCAPE
              IF Protokollieren=1 THEN Protokoll("Haupt: Escape gedrueckt")
              Dummy=AnzeigeHilfe3("Loeschen")
              Dummy=AnzeigeHilfe2("Loeschen")
              Dummy=AnzeigeHilfe1("Loeschen")
              Dummy=AnzeigeFensterUnten("Loeschen")
              HilfefensterNr=0
              KopfFenster("Loeschen", "")
              Figur("FigurenLoeschen", 0, 0, 0, "Escape")
              Dummy=Fenster("LoeschAlleFenster", 0, 0, 0, 0, 0, "Escape")
              Dummy=Objekt("LoescheAlleObjekte", 0, 0, 0, 0, 0, "Escape")
              IF Hintergrundbildpointer <> 0 THEN
                 IMAGEDESTROY(Hintergrundbildpointer)
                 Hintergrundbildpointer=0
              END IF
              IF Protokollieren=1 THEN Protokoll("Haupt: Escape fertig, in Aufloesungswahl")
              IF FmodOKFlag  > 0 THEN Dummy = Musik ( "MusikBeenden", "", 0) :' Bei Screenwechsel Spiel in Einstellungen hackert Musik, drum aus
              LassBildAufloesungWaehlen
         CASE "9"
               Figur("RichtungRechts", FigurNr, 0, 0, FigurNameHpt)
               Figur("RichtungHoch", FigurNr, 0, 0, FigurNameHpt)
         CASE "3"
               Figur("RichtungRechts", FigurNr, 0, 0, FigurNameHpt)
               Figur("RichtungRunter", FigurNr, 0, 0, FigurNameHpt)
         CASE "1"
               Figur("RichtungLinks", FigurNr, 0, 0, FigurNameHpt)
               Figur("RichtungRunter", FigurNr, 0, 0, FigurNameHpt)
         CASE "7"
               Figur("RichtungLinks", FigurNr, 0, 0, FigurNameHpt)
               Figur("RichtungHoch", FigurNr, 0, 0, FigurNameHpt)
         CASE "+" : Figur("Schneller", FigurNr, 0, 0, FigurNameHpt)
         CASE "-" : Figur("Langsamer", FigurNr, 0, 0, FigurNameHpt)
         CASE "g", "G" : Figur("WechsleBild", FigurNr, 0, 0, "gelbzyli")
         CASE "r", "R" : Figur("WechsleBild", FigurNr, 0, 0, "rotekuge")
         CASE "b", "B" : Figur("WechsleBild", FigurNr, 0, 0, "blaukuge")
         CASE "z", "Z" : Figur("WechsleBild", FigurNr, 0, 0, "blauzyli")
         CASE "t", "T" : Figur("WechsleBild", FigurNr, 0, 0, "tarzan01")
         CASE "p", "P" : Figur("WechsleBild", FigurNr, 0, 0, "hottehue")
         CASE "K", "k" : Figur("WechsleBild", FigurNr, 0, 0, "koenigin")
         CASE "L", "l" : Figur("WechsleBild", FigurNr, 0, 0, "koenigbl")
         CASE "D", "d" : Figur("WechsleBild", FigurNr, 0, 0, "arnolauf")
         CASE "S", "s" : Figur("WechsleBild", FigurNr, 0, 0, "arnorenn")
         CASE "F", "f" : Figur("WechsleBild", FigurNr, 0, 0, "grunzyli")
         CASE "N", "n" : IF ZeigLaufNummer=1 THEN  :ZeigLaufNummer=0 : ELSE : ZeigLaufNummer=1 : END IF
         CASE "C", "c" : IF ZeigKollision=1  THEN  :ZeigKollision=0  : ELSE : ZeigKollision=1  : END IF
         CASE CHR(8) : 'RueckTaste
               IF FigurNr = 1 THEN : FigurNr=MaxFigur : ELSE : FigurNr=FigurNr-1 : END IF
               Figur("MachAktiv", FigurNr, 0, 0, "")
         CASE CHR(9) : ' Tabulatortaste
               IF FigurNr >= MaxFigur THEN FigurNr=1 ELSE FigurNr=FigurNr+1
               Figur("MachAktiv", FigurNr, 0, 0, "")
         CASE "x", "X"
            Dummy = FragDezWertAb("Geben Sie den X-RichtungsSprungWeite ein, aktuell = " & STR(FG(FigurNr).XStep) & ")")
            IF LEN(Dummy) > 0 THEN Figur("SetzXRichtung", FigurNr, VAL(Dummy), 0, "")
         CASE "y", "Y"
            Dummy = FragDezWertAb("Geben Sie den Y-RichtungsSprungWeite ein, aktuell = " & STR(FG(FigurNr).YStep) & ")")
            IF LEN(Dummy) > 0 THEN Figur("SetzYRichtung", FigurNr, VAL(Dummy), 0, "")
         CASE "h", "H", CHR(255) & CHR(59)
            HilfefensterNr = HilfefensterNr + 1
            IF HilfefensterNr > HilfeFensterZahl THEN HilfefensterNr=0
            SELECT CASE HilfefensterNr
               CASE 0 : Dummy=AnzeigeFensterUnten("Anzeigen")
               CASE 1 : Dummy=AnzeigeHilfe1("Anzeigen")
               CASE 2 : Dummy=AnzeigeHilfe2("Anzeigen")
               CASE 3 : Dummy=AnzeigeHilfe3("Anzeigen")
            END SELECT
         CASE "1", "!"
            Dummy = Objekt("WerteAnzeigen", 1, 0, 0, 0, 0, "")
         CASE "A", "a"
            'About angeklickt
            TempX = TempMitte-310 : TempY = TempHoehe-190 : TempStep = 20
            Print3DString("FB-MOVIN - EASTLER - 2008", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DIESES PROGRAMM ENTSTAND UM ZU TESTEN, WIE SCHNELL FREEBASIC (VER. 0.18.5)", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("MIT GRAFIK UMGEHEN KANN.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DA FREEBASIC NICHT KLEIN ZU KRIEGEN WAR KAMEN ERST DIE ANIMATIONEN DAZU,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DANN DIE MAUSSTEUERUNG UND ALS LETZTER SCHLAG NOCH SOUND MIT FMOD.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("ERGEBNIS: SIE SEHEN ES JA, HAB FREEBASIC NICHT KLEIN GEKRIEGT :-)", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("GRATULATION AN DIE FREEBASIC-MACHER !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("TASTE DRCKEN ! !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            DO WHILE INKEY="" : LOOP
            PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
            TempY = TempHoehe-190
            Print3DString("DER SOUND LUFT UNTER WINDOWS (FMOD).", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("UNTER LINUX (KNOPPIX 5.1.1) LUFT DER SOUND EBENFALLS,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("IM DOS GIBTS KEIN FMOD :-( ALSO AUCH KEIN SOUND ", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("BEI DEN GRAFIKAUFLSUNGEN RICHTET SICH DAS PROGRAMM", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("NACH IHRER GRAFIKKARTE.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("FBMOVIN KANN IN 640x480 800x600 1024x768 und 1280x1024", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("JEWEILS MIT 8, 15, 16, 24 UND 32bit-FARBTIEFE UMGEHEN.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("AUS DIESEN MGLICHKEITEN BIETET FBMOVIN IHNEN NUR DIEJENIGEN AN,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DIE IHRE GRAFIKKARTE AUCH BEHERRSCHT.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("TASTE DRCKEN ! !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            DO WHILE INKEY="" : LOOP
            PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
            TempY = TempHoehe-195
            Print3DString("IM LINUX SCHREIT FB NACH DER FMOD-LIB, FALLS DIESE", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("NOCH NICHT INSTALLIERT IST.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("HAB ICH KURZERHAND VON WWW.FMOD.ORG DAS PAKET", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("FMODAPI375LINUX.TAR.GZ", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("HERUNTER GELADEN, DARAUS NUR DIE DATEI:", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("LIBFMOD-3.5.SO  IN DAS VERZEICHNIS", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("/USR/LIB ENTPACKT.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DANN ALS ROOT IN DER KONSOLE MIT:", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("LN - S /USR/LIB/LIBFMOD-3.5.so /USR/LIB/LIBFMOD.SO", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("EINEN SYMBOLISCHEN LINK AUF DIESE DATEI GESETZT,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DER DEN NAMEN LIBFMOD.SO TRGT. WEIL GENAU DANACH", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("SUCHT FreeBASIC, UND NICHT EINE LIBFMOD MIT VERSIONSZAHL", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("SICHERHEITSHALBER GLEICH NOCH EINEN LINK IN ", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("/USR/LOCAL/LIB/FREEBASIC  UND IN /LIB", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("NACH DIESER AKTION KONNTE ICH UNTER KNOPPIX 5.1.1.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DAS LISTING DIESES PROGRAMMES KOMPILIEREN :-)", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("TASTE DRCKEN ! !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            DO WHILE INKEY="" : LOOP
            PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
            TempY = TempHoehe-190
            Print3DString("ERFOLGREICH GETESTET HAB ICH DIESES LISTING MIT:", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("W98SE 500MHZ 196MB RAM 32MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("W98SE 400MHZ 128MB RAM 4MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("W98SE LAP-CELERON400 196MB RAM 4MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("KNOPPIX-LINUX 500MHZ 196MB RAM 32MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("MS-DOS 7.0 500MHZ 196MB RAM 32MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("WINXP 5200MHZ 1,75GB RAM 256MB OB-GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("WINXP 500MHZ 128 RAM 4MB GRAFIK NO SOUNDCARD", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("WINXPPRO 1600MHZ 256 RAM 32MB GRAFIK", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("TASTE DRCKEN ! !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            Dummy=""
            DO WHILE INKEY="" : LOOP
            PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
            TempY = TempHoehe-190
            Print3DString("EINIGE FIGUREN HAB ICH MIT ANIM8OR SELBER ERSTELLT,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("DIE ROTE UND BLAUEN KNIGINNEN SOWIE DER ", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("HELLBLAUE ANTON", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("HAB ICH VON REINERSTILESET.4PLAYERS.DE GELIEHEN,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("REINER SCHREIBT AUF SEINER SEITE, ICH DARF DAS,", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("EIN GROSSES DANKESCHN AN REINER :-)", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("Versuchen Sie auch mal, hier mit der Escape-Taste", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("die About-Anzeige zu beenden.", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("Mit Escape wird (absichtlich-grins) der Text", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("nicht gelscht, die Figuren mssen dann ", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep
            Print3DString("aurfumen, soweit sie knnen....", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("Eastler_Dart (www.eastler.de/FreeBasic/fbmovin/fbmovin.htm)", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            TempY = TempY + TempStep + TempStep
            Print3DString("TASTE DRCKEN ! !", TempX, TempY, RGB(164,164,255), RGB(96,96,128), RGB(255,255,255), 0, 0)
            DO WHILE Dummy="" : Dummy = inkey : LOOP
            IF Dummy <> CHR(27) THEN PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
            Dummy = ""
         CASE ELSE
'            Dummy = "Tastencode war: " & STR(Taste) & " Laenge=" & STR(LEN(Taste)) & "  "
'            FOR Zaehler = 1 TO LEN(Taste)
'               Dummy = Dummy & "ASC(" & ASC(MID(Taste,Zaehler)) & ") "
'            NEXT Zaehler
      END SELECT
   END IF
   Taste = inkey '$()
'   IF LEN(Taste)>0 THEN
'      LOCATE 2,10
'      PRINT "Laenge Taste = " & STR(LEN(Taste)) & " =                            ";
'      LOCATE 2,26
'      FOR Zaehler=1 TO LEN(Taste)
'         PRINT "CHR(" & STR(ASC(MID(Taste, Zaehler, 1))) & ")";
'      NEXT Zaehler
'      PRINT
'   END IF
LOOP

Fehler:
CLS
PRINT "FEHLER #"; Err; "!"
'---------------------------------------------------------------
   'Auf Tastendruck warten
' Dummy = "Eingabelaenge:" & STR(LEN(Taste)) & "Tastencode war: " & STR(Taste) & " Zaehler = " & STR(Zaehler)
' TEXT_Zentriert(Dummy,255)
TEXT_Zentriert("Jegliche Taste = Programmende",255)
Dummy=readkey()
'---------------------------------------------------------------
Programmende:
Dummy = Fenster ("LoeschAlleFenster", 0, 0, 0, 0, 0, "Programmende")

'
'===============================================================
'Unterprogramme
'---------------------------------------------------------------
SUB LassBildAufloesungWaehlen()
   DIM AS INTEGER Modi, Breite, Hoehe, Tiefe, ModiZaehler, Modus(4), LaufNr, NextFreeFile
   DIM AS INTEGER FontHoehe, LcdXOffs, LcdYOffs, LcdBreit
   STATIC AS INTEGER Initialisiert, Aufloesungen(4,4), HintergrundIstGeladenFlag, Mittelfenster
   STATIC AS STRING WahlChars
   DIM AS STRING Taste, AflDummy
   DIM AS INTEGER STasteX, STasteY, plusTasteX, PlusTasteY, MinusTasteX, MinusTasteY, ModiX, DummyY, EscTasteX, EscTasteY

   Modus(1) = 15 : Modus(2) = 16 : Modus(3) = 24 : Modus(4) = 32
   '------------------------------------------------------------
   'Anwender informieren
   IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): gestartet")
   VarScreen_T = 16
   VarScreen_W=640
   VarScreen_H=480
   ObererLaufRand=KopfFensterHoehe
   SCREEN 18,VarScreen_T, ,1
   IF FmodOKFlag  > 0 THEN AflDummy = Musik ( "Intro", "", 0)

               KopfFenster("Erstellen", "FB-Movin 0.1 - Startbildschirm")
               KopfFenster("Anzeigen", "")
   LOCATE 6,23
   PRINT "   Frage Ihre Grafikkarte nach"
   LOCATE 7,23
   PRINT "vorhandenen Bildschirmaufloesungen"
   '---------------------------------------------
   'alle Auflsungen einzeln durchgehen und auf
   '640x480 800x600 1024x768 und 1280x1024
   'jeweils in den Tiefen 15,16,24 und 32bit pruefen
   ' falls vorhanen in Modi(Tiefe,Auflsung) eine 1 rein fuer "vorhanden"
   IF Initialisiert=0 THEN
      FOR ModiZaehler=1 TO 4
         Modi = SCREENLIST(Modus(ModiZaehler))
         WHILE (Modi)
            Breite = HIWORD(Modi)
            Hoehe = LOWORD(Modi)
            IF Breite= 640 AND Hoehe= 480 THEN Aufloesungen(ModiZaehler,1)=1
            IF Breite= 800 AND Hoehe= 600 THEN Aufloesungen(ModiZaehler,2)=1
            IF Breite=1024 AND Hoehe= 768 THEN Aufloesungen(ModiZaehler,3)=1
            IF Breite=1280 AND Hoehe=1024 THEN Aufloesungen(ModiZaehler,4)=1
            Modi = SCREENLIST
         WEND
      NEXT ModiZaehler
      Initialisiert=1
   END IF
   '---------------------------------------------
   'Anwender eine Maske anbieten
               'Mittelteil als leeres Fenster mit Hintergrund wie Titelschrift
               Mittelfenster = VAL(Fenster ("Erstellen", 0, 0, 0, 0, 0, "Mittel-Fenster "))
               AflDummy = Fenster ("SetzTitel", Mittelfenster, 1, 0, 0, 0, "Mittel-Fenster " & STR(MittelFenster))
               AflDummy = Fenster ("SetzXY", Mittelfenster, 0,ObererLaufRand, 0, 0, "")
               AflDummy = Fenster ("SetzGrundfarbe", Mittelfenster, 50, 50, 50, 0, "")
               AflDummy = Fenster ("SetzRahmenfarbe", Mittelfenster, 100, 100, 100, 0, "")
               AflDummy = Fenster ("SetzGroesse", Mittelfenster, 639, 480-KopfFensterHoehe-100, 0, 0, "")
               AflDummy = Fenster ("SetzRahmenAbstand", Mittelfenster, 0, 0, 0, 0, "")
               AflDummy = Fenster ("FUELLDATEIMUSTER", Mittelfenster, 50, 45, 0, 0, "pattern" & VZT & "metall2.bmp")
               AflDummy = Fenster ("ZeigAn", Mittelfenster, 0, 0, 0, 0, "")
   'SCREENAUFLOESUNGEN ANZEIGEN
   LcdXOffs=430
   LcdYOffs=90
   LcdBreit=170
   FOR ModiZaehler=1 TO 16
      FontHoehe=GibFontHoehe(2)+2
      LINE (LcdXOffs-3-1, LcdYOffs+(ModiZaehler-1)*(FontHoehe+3)-1)-STEP(30*GibFontBreite(2)+3+1, FontHoehe-1+1), RGB(0,0,0), B
      LINE (LcdXOffs-3, LcdYOffs+(ModiZaehler-1)*(FontHoehe+3))-STEP(30*GibFontBreite(2)+3+1, FontHoehe-1+1), RGB(160,150,150), B
      LINE (LcdXOffs-3, LcdYOffs+(ModiZaehler-1)*(FontHoehe+3))-STEP(30*GibFontBreite(2)+3, FontHoehe-1), RGB(64,0,0), BF
      PUT (LcdXOffs-24, LcdYOffs+(ModiZaehler-1)*(FontHoehe+3)-3), Bild("GibBildPtr", "HG_bild" & VZT & "TastLe15.bmp"), TRANS
      ModiX = LcdXOffs-24
   NEXT ModiZaehler
   LaufNr=0
   LINE (LcdXOffs-3-1, LcdYOffs+1-23-1)-STEP(25*GibFontBreite(2)+3+1, FontHoehe-1+1), RGB(0,0,0), B
   LINE (LcdXOffs-3, LcdYOffs+1-23)-STEP(25*GibFontBreite(2)+3+1, FontHoehe-1+1), RGB(160,150,150), B
   LINE (LcdXOffs-3, LcdYOffs+1-23)-STEP(3+25*GibFontBreite(2), FontHoehe), RGB(64,0,0), BF
   PrintString("Spielstart mit Aufloesung", LcdXOffs-2, LcdYOffs-20, RGB(128,128,255),2, 0)
   'Je nachdem ob eine Auflsung auf der Grafikkarte gefunden wurde, diese Mglichkeit anzeigen
   FOR ModiZaehler=1 TO 4
      IF Aufloesungen(ModiZaehler,1) = 1 THEN
           PrintString(CHR$(61+ModiZaehler*4), LcdXOffs-18, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3), 0, 1, 0)
           WahlChars = WahlChars + CHR$(61+ModiZaehler*4)
           PrintString("  640 x 480 Pixel x " & STR(Modus(ModiZaehler)) & " bits", LcdXOffs, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3), RGB(128,128,255),2, 0)
      END IF
      IF Aufloesungen(ModiZaehler,2) = 1 THEN
           PrintString(CHR$(62+ModiZaehler*4), LcdXOffs-18, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+FontHoehe+3, 0, 1, 0)
           WahlChars = WahlChars + CHR$(62+ModiZaehler*4)
           PrintString("  800 x 600 Pixel x " & STR(Modus(ModiZaehler)) & " bits", LcdXOffs, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+FontHoehe+3, RGB(128,128,255),2, 0)
      END IF
      IF Aufloesungen(ModiZaehler,3) = 1 THEN
           PrintString(CHR$(63+ModiZaehler*4), LcdXOffs-18, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+2*(FontHoehe+3), 0, 1, 0)
           WahlChars = WahlChars + CHR$(63+ModiZaehler*4)
           PrintString(" 1024 x 768 Pixel x " & STR(Modus(ModiZaehler)) & " bits", LcdXOffs, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+2*(FontHoehe+3), RGB(128,128,255),2, 0)
      END IF
      IF Aufloesungen(ModiZaehler,4) = 1 THEN
           PrintString(CHR$(64+ModiZaehler*4), LcdXOffs-18, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+3*(FontHoehe+3), 0, 1, 0)
           WahlChars = WahlChars + CHR$(64+ModiZaehler*4)
           PrintString(" 1280 x1024 Pixel x " & STR(Modus(ModiZaehler)) & " bits", LcdXOffs, LcdYOffs+1+(ModiZaehler-1)*4*(FontHoehe+3)+3*(FontHoehe+3), RGB(128,128,255),2, 0)
      END IF
   NEXT ModiZaehler
'---------------------
   'Figurenanzahl
   LcdFeld("ANZAHL FIGUREN", LcdXOffs-300, LcdYOffs-20, RGB(170,160,64), RGB(64,0,0), 2)
   AflDummy=STR(MaxFigur)
   AflDummy = SPACE(5-LEN(AflDummy)) + AflDummy
   LcdFeld(AflDummy, LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10, RGB(170,160,64), RGB(64,0,0), 2)
      '- Taste davor anzeigen
      MinusTasteX = LcdXOffs-294
      MinusTasteY = LcdYOffs-20+GibFontHoehe(2)+7
      PUT (MinusTasteX, MinusTasteY), Bild("GibBildPtr", "HG_bild" & VZT & "TastLe15.bmp"), TRANS
      PrintString("-", LcdXOffs-290+2, LcdYOffs-20+GibFontHoehe(2)+12, 0, 1, 0)
      '+ Taste dahinter anzeigen
      PlusTasteX = LcdXOffs-266+LEN(AflDummy)*GibFontBreite(2)
      PlusTasteY = LcdYOffs-20+GibFontHoehe(2)+7
      PUT ( PlusTasteX, PlusTasteY), Bild("GibBildPtr", "HG_bild" & VZT & "TastLe15.bmp"), TRANS
      PrintString("+", LcdXOffs-270+8+LEN(AflDummy)*GibFontBreite(2)+3, LcdYOffs-20+GibFontHoehe(2)+12, 0, 1, 0)

'---------------------
   'MUSIK - SOUND
   LcdFeld("SOUND / MUSIK", LcdXOffs-300, LcdYOffs-20+100, RGB(64,200,64), RGB(64,0,0), 2)
   IF FmodOKFlag > 0 THEN AflDummy=" EIN  " ELSE AflDummy=" AUS  "
   IF FmodEinbinden = "nein" THEN  AflDummy="No Dos"
   LcdFeld(AflDummy, LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10+100, RGB(64,200,64), RGB(64,0,0), 2)
      'S-Taste dahinter
      STasteX = LcdXOffs-294
      STasteY = LcdYOffs-20+GibFontHoehe(2)+10+100-3
      PUT (STasteX, STasteY), Bild("GibBildPtr", "HG_bild" & VZT & "TastLe15.bmp"), TRANS
      PrintString("S", STasteX+6, STasteY+5, 0, 1, 0)

'---------------------
   'ESC - Programmende
      'Esc-Taste + LCD-Feld mit "Programmende"
      LcdFeld("Programmende", LcdXOffs-300, LcdYOffs-20+200, RGB(200,64,64), RGB(64,0,0), 2)
      EscTasteX = LcdXOffs-294
      EscTasteY = LcdYOffs-20+GibFontHoehe(2)+10+200-3
      PUT (EscTasteX, EscTasteY), Bild("GibBildPtr", "HG_bild" & VZT & "TastLe15.bmp"), TRANS
      PrintString("E", EscTasteX+2, EscTasteY+5, 0, 1, 0)
      PrintString("S", EscTasteX+5, EscTasteY+5, 0, 1, 0)
      PrintString("C", EscTasteX+9, EscTasteY+5, 0, 1, 0)
'---------------------
   StartFuss("Erstellen")
   StartFuss("Anzeigen")
   '--------------------------------------
   'TASTENABFRAGESCHLEIFE EINSTELLUNGSBILD
   '--------------------------------------
   DO UNTIL ( INSTR(WahlChars, UCASE(Taste)) > 0 OR Taste = CHR(27) )
      Taste = INKEY
      IF MausFlag = 1 THEN SLEEP 99 : SLEEP 99 : SLEEP 99 : MausFlag = 0
      MausRes = GETMOUSE ( MausX, MausY, , MausButt )
      IF MausRes = 0 THEN
         'nur wenn Maus im Fenster ist prfen
         IF ( (MausX >= STasteX) AND (MausX <= STasteX+18) AND (MausY >= STasteY) AND (MausY <= STasteY+18) AND (MausButt AND 1) ) THEN Taste = "s" : MausFlag = 1
         IF ( (MausX >= PlusTasteX) AND (MausX <= PlusTasteX+18) AND (MausY >= PlusTasteY) AND (MausY <= PlusTasteY+18) AND (MausButt AND 1) ) THEN Taste = "+" : MausFlag = 1
         IF ( (MausX >= MinusTasteX) AND (MausX <= MinusTasteX+18) AND (MausY >= MinusTasteY) AND (MausY <= MinusTasteY+18) AND (MausButt AND 1) ) THEN Taste = "-" : MausFlag = 1
         IF ( (MausX >= ModiX) AND (MausX <= ModiX+18) AND (MausY >= 89) AND ( MausY <= 358) AND (MausButt AND 1) ) THEN
            DummyY = MausY - LcdYOffs + 20
            Taste=chr(64+INT(DummyY/17))
         END IF
         IF ( (MausX >= EscTasteX) AND (MausX <= EscTasteX+18) AND (MausY >= EscTasteY) AND (MausY <= EscTasteY+18) AND (MausButt AND 1) ) THEN Taste = chr(27) : MausFlag = 1
      END IF
      SELECT CASE Taste
         'fuer alle Tasten, die nur was ndern, aber nicht aus der Inkey-Routine springen
         CASE "+"
            'Anzahl Figuren erhhen
            MaxFigur = MaxFigur + 1
            IF MaxFigur > 1024 THEN MaxFigur = 1024
            AflDummy=STR(MaxFigur)
            AflDummy = SPACE(5-LEN(AflDummy)) + AflDummy
            LcdFeld(AflDummy, LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10, RGB(170,160,64), RGB(64,0,0), 2)
         CASE "-"
            'Anzahl Figuren vermindern
            MaxFigur = MaxFigur - 1
            IF MaxFigur < 1 THEN MaxFigur = 1
            AflDummy=STR(MaxFigur)
            AflDummy = SPACE(5-LEN(AflDummy)) + AflDummy
            LcdFeld(AflDummy, LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10, RGB(170,160,64), RGB(64,0,0), 2)
         CASE "S", "s"
            'Sound/musik an/aus
            IF FmodOKFlag > 0 THEN
               'bis jetzt war eingeschalten
               AflDummy = Musik ( "MusikBeenden", "", 0)
               AflDummy = Musik ( "FmodBeenden", "", 0)
               FmodOKFlag = -1
               LcdFeld(" AUS  ", LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10+100, RGB(64,200,64), RGB(64,0,0), 2)
            ELSE
               'bis jetzt war ausgeschalten
                  AflDummy = Musik ( "Intro", "", 0)
                  IF FmodOKFlag > 0 THEN
                     'Falls das Einschalten von Fmod Fehlerfrei war,
                     'steht ja in FmodOKFlag ne 1, also anzeigen
                     LcdFeld(" EIN  ", LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10+100, RGB(64,200,64), RGB(64,0,0), 2)
                  ELSE
                     ' Anwender wollte einschalten, aber Fehler bei Fmod-Start
                     IF FmodEinbinden = "nein" THEN
                        'Fmod wurde gar nicht eingebunden (DOS?)
                        LcdFeld("NoFmod", LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10+100, RGB(64,200,64), RGB(64,0,0), 2)
                     ELSE
                        LcdFeld("FEHLER", LcdXOffs-270, LcdYOffs-20+GibFontHoehe(2)+10+100, RGB(64,200,64), RGB(64,0,0), 2)
                     END IF
                  END IF
            END IF
         CASE ELSE
            IF FmodOKFlag > 0 THEN
               'falls Musik eingeschalten, immer wieder introstart fr Repeat
               AflDummy = Musik ( "Intro", "", 0)
            END IF
      END SELECT
   LOOP
              IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): Auswahl wurde beantwortet, Kopffenster loeschen")
              KopfFenster("Loeschen", "") ' Aus Startbildschirem
              AflDummy=Fenster("LoeschAlleFenster", 0, 0, 0, 0, 0, "Aufloesungfertig")
              StartFuss("Loeschen")
   SELECT CASE UCASE(Taste)
      CASE "A","B","C","D"
         VarScreen_T=15
      CASE "E","F","G","H"
         VarScreen_T=16
      CASE "I","J","K","L"
         VarScreen_T=24
      CASE "M","N","O","P"
         VarScreen_T=32
   END SELECT
   IF FmodOKFlag  > 0 THEN AflDummy = Musik ( "MusikBeenden", "", 0) :' Bei Screenwechsel Spiel in Einstellungen hackert Musik, drum aus
   SELECT CASE UCASE(Taste)
      CASE CHR(27)
         IF FmodOKFlag  > 0 THEN AflDummy = Musik ( "MusikBeenden", "", 0)
         IF FmodOKFlag  > 0 THEN AflDummy = Musik ( "FmodBeenden", "", 0)
         SetzDesktopWieInfo 'in Sub wird nur unter Linux ausgefhrt, Knoppix behlt sonst nach ProgEnde 640x480 aus whlschirm, warum auch immer
         SYSTEM
      CASE "A","E","I","M"
         TempMitte = 320 : TempHoehe = 240
         SCREEN 18, VarScreen_T, ,1
      CASE "B","F","J","N"
         TempMitte = 400 : TempHoehe = 300
         SCREEN 19, VarScreen_T, ,1
      CASE "C","G","K","O"
         TempMitte = 512 : TempHoehe = 384
         SCREEN 20, VarScreen_T, ,1
      CASE "D","H","L","P"
         TempMitte = 640 : TempHoehe = 512
         SCREEN 21, VarScreen_T, ,1
   END SELECT
   SCREENINFO FbGfxBreite, FbGfxHoehe, FbGfxTiefe
   VarScreen_T = FbGfxTiefe
   VarScreen_W=FbGfxBreite
   VarScreen_H=FbGfxHoehe
   IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): Screen " & STR(FbGfxBreite) & "x" & STR(FbGfxHoehe) & "x" & STR(FbGfxTiefe) & " ist gewhlt")
   GesRepSecs=0.1
   GesMaxRepSecs=0.3
   'HINTERGRUNDBILD UND WAS SO DRAN HNGT
   'Hintergrundbild aus Datei in Speicher einlesen DIE IST ABER ERST MAL 1280x1024 PIXEL GROSS!
         Hintergrundbildname="HG_bild" & VZT & "Karogrun.bmp"
         NextFreeFile = FREEFILE
         Open Hintergrundbildname FOR INPUT AS #NextFreeFile
            IF LOF(NextFreeFile) > 0 THEN DateiExistiert = 1 ELSE DateiExistiert = 0
            Get #NextFreeFile, 19, HgBildBreite              'Breite aus der BMP-Datei auslesen
            Get #NextFreeFile, 23, HgBildHoehe               'Hhe aus der BMP-Datei auslesen
         CLOSE #NextFreeFile
         IF DateiExistiert = 1 THEN
            IF HintergrundGesamtPointer <> 0 THEN
               IMAGEDESTROY(HintergrundGesamtPointer)
               HintergrundGesamtPointer=0
            END IF
            HintergrundGesamtPointer = IMAGECREATE(HgBildBreite,HgBildHoehe,0)
            IF HintergrundGesamtPointer = 0 THEN
               AflDummy="Bildbitmap konnte nicht erstellt werden  HintergrundGesamtPointer=" & STR$(HintergrundGesamtPointer) & " - Taste = Ende"
               TEXT_Zentriert(AflDummy, 255)
               AflDummy=readkey()
               SYSTEM
            END IF
            BLOAD(Hintergrundbildname, HintergrundGesamtPointer)
         ELSE
            AflDummy = "Soll Hintergrund aus der Datei " & Hintergrundbildname & " aufbauen Datei existiert jedoch nicht. Taste = Programmende"
            textout_centre(VarScreen, font, AflDummy, 30, 460, 255)
            AflDummy=readkey()
            IMAGEDESTROY(HintergrundGesamtPointer)
            SYSTEM
         END IF
         'Da nun die Maximumgroesse vorhanden ist, eine angepate Gre zu der grad gewhlten Screenauflsung erstellen
         HGBildBreite=VarScreen_W
         HGBildHoehe=VarScreen_H-KopfFensterHoehe-FensterUntenHoehe : ' 50 fr Kopffenster und 100 fuer FensterUnten abziehen
         Hintergrundbildpointer = IMAGECREATE(HgBildBreite, HgBildHoehe, 0)
         IF Hintergrundbildpointer = 0 THEN
            PRINT "Konnte fuer das Hintergrundbild in angepater Groesse keinen Speicher kriegen, breche ab
            AflDummy=readkey()
            SYSTEM
         END IF
         PUT Hintergrundbildpointer, (0,0), HintergrundGesamtPointer, (0,0)-STEP(HgBildBreite-1, HgBildHoehe-1), PSET
         IF HgBildBreite < FbGfxBreite THEN HgAnzeigeBreite=HgBildBreite-1 ELSE HgAnzeigeBreite=FbGfxBreite-1
         IF HgBildHoehe  < FbGfxHoehe  THEN HgAnzeigeHoehe =HgBildHoehe-1  ELSE HgAnzeigeHoehe =FbGfxHoehe-1
         'und jetzt das Hintergrundbild mit dem maximalgroen bild wieder lschen / Speicher freigeben
         IF HintergrundGesamtPointer<> 0 THEN IMAGEDESTROY(HintergrundGesamtPointer)
         HintergrundGesamtPointer=0
   IF VarScreen_W > HgBildBreite THEN LinkerLaufRand = (VarSCREEN_W-HgBildBreite)\2 ELSE LinkerLaufRand = 0
   IF VarScreen_W > LinkerLaufRand+HgBildBreite THEN RechterLaufRand = LinkerLaufRand+HgBildBreite ELSE RechterLaufRand = VarScreen_W
'   IF VarSCREEN_H > HgBildHoehe THEN ObererLaufRand = (VarSCREEN_H-HgBildHoehe)\2 ELSE ObererLaufRand = 0
   IF VarSCREEN_H > HgBildHoehe+KopfFensterHoehe THEN ObererLaufRand = KopfFensterHoehe ELSE ObererLaufRand = 0
   IF ObererLaufRand + HgBildHoehe < VarSCREEN_H THEN UntererLaufRand = ObererLaufRand + HgBildHoehe ELSE UntererLaufRand = VarSCREEN_H

   IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): Hintergrund steht, Objekte erstellen")
   'OBJEKTE IN DAS HINTERGRUNDBILD KOPIEREN
   AflDummy = Objekt("Erstellen", 0, 0, 0, 0, 0, "AufloesungFragen")
   AflDummy = Objekt("InHintergrundEinbinden", 1, 0, 0, 0, 0, "AufloesungFragen")
   AflDummy = Objekt("InHintergrundEinbinden", 2, 0, 0, 0, 0, "AufloesungFragen")
   'Hintergrundbild ist nun komplett, ab auf den Schirm
               PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
               KopfFenster("Erstellen", "FB-MOVIN 0.1")
               KopfFenster("Anzeigen", "")
               AflDummy=AnzeigeFensterUnten("Erstellen")
               AflDummy=AnzeigeFensterUnten("Anzeigen")
               AflDummy=AnzeigeHilfe1("Erstellen")
               AflDummy=AnzeigeHilfe2("Erstellen")
               AflDummy=AnzeigeHilfe3("Erstellen")
   IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): Figuren erstellen")
   FigurNr=1
   Figur("FigurenInit", 0, 0, 0, "AufloesungFragen")
   Figur("MachAktiv", FigurNr, 0, 0, "")
   IF Protokollieren=1 THEN Protokoll("LassBildAufloesungWaehlen(): Beendet, Spiel in Tastenroutine starten")
END SUB
'---------------------------------------------------------------
FUNCTION FragDezWertAb (DezAnzeigeText AS STRING) AS STRING
    DIM  AS INTEGER DezTaste, DezOkFlag
    STATIC AS STRING EingabeString, EingabeZahl
    STATIC AS INTEGER StartPosX, StartPosY, ZeigeBreite, ZeigeHoehe
    StartPosX = 20
    StartPosY = VarScreen_H - 3 * GibFontHoehe(font)
    StartPosY = 20
    ZeigeBreite=LEN(DezAnzeigeText)*GibFontBreite(font) + 10
    ZeigeHoehe=2*GibFontHoehe(font) + 10
    EingabeString = ""
    DezOkFlag = 0
    LINE (StartPosX,StartPosY)-STEP(ZeigeBreite,ZeigeHoehe), RGB(0,0,0), BF
'    Line [target,] [[STEP] (x1, y1)]-[STEP] (x2, y2) [, [color][, [B|BF][, style]]]
    PrintString(DezAnzeigeText, StartPosX+5, StartPosY+5, RGB(255, 0, 0), font, 0)
'    textout_centre(VarScreen,font,DezAnzeigeText, 100, VarScreen_H - 4*GibFontHoehe(font), RGB(255, 0, 0))
    DO UNTIL (DezOkFlag = 1) : ' 0-9 und punkt zulassen
          'Erst Mal Anzeigen, was schon drin ist
          LINE (StartPosX,StartPosY+GibFontHoehe(font))-STEP(ZeigeBreite,ZeigeHoehe-GibFontHoehe(font)), RGB(0,0,0), BF
          PrintString(EingabeString & "_", StartPosX+5, StartPosY+5+GibFontHoehe(font), RGB(255, 0, 0), font, 0)
'          textout_centre(VarScreen,font,EingabeString & "_", StartPosX, StartPosY, RGB(255, 0, 0))
          EingabeZahl = FragZahlen
          SELECT CASE EingabeZahl
             CASE "-"
                'Minus geht nur ganz an vorderster Eingabestelle
                IF LEN(EingabeString) = 0 THEN EingabeString = EingabeString & "-"
             CASE "#"
                'War RckDezTaste, Falls schon eingaben in Var, dann letzer Buchtstabe raus
                IF LEN(EingabeString) > 0 THEN EingabeString = LEFT(EingabeString, LEN(EingabeString)-1)
             CASE "."
                'Dezimalpunkt, aber nur einmal!
                IF INSTR(EingabeString, ".") = 0 THEN EingabeString = EingabeString & "."
             CASE "Esc"
                EingabeString=""
                DezOkFlag=1
             CASE "Return"
                DezOkFlag=1
             CASE ELSE
                'alle normalen Zahlen
                EingabeString = EingabeString & EingabeZahl
          END SELECT
    LOOP
    FragDezWertAb = EingabeString
END FUNCTION
'---------------------------------------------------------------
FUNCTION FragZahlen () AS STRING
    DIM AS INTEGER FragOkFlag
    DIM AS STRING FragTaste, FragDummy
    FragOkFlag=0
    FragDummy = ""
    DO UNTIL (FragOkFlag = 1) : ' 0-9 und punkt zulassen
       FragTaste = readkey()
       SELECT CASE FragTaste
          CASE "0","1","2","3","4","5","6","7","8","9","-"
             FragDummy = FragTaste
          CASE ".",","
             FragDummy="."
          CASE CHR$(8)
             FragDummy = "#" :'RckFragTaste
          CASE CHR$(27)
             FragDummy = "Esc" :'Escape
             FragOkFlag = 1
          CASE CHR$(13)
             FragDummy = "Return" :'Enter oder Return
             FragOkFlag = 1
          CASE ELSE
             textout_centre(VarScreen,font,"Eingabe nicht zu Akzeptieren! FragTaste war:" & STR$(FragTaste), 20, VarScreen_H - 1*GibFontHoehe(font), RGB(255, 0, 0))
       END SELECT
       IF LEN(FragDummy) > 0 THEN FragOkFlag = 1
    LOOP
    FragZahlen=FragDummy
END FUNCTION
'---------------------------------------------------------------
SUB TEXT_Zentriert(AnzeigeText AS STRING, TextFarbNr AS INTEGER)
   DIM AS INTEGER VarScreenMitte
'   ScreenLock
    LOCATE TextZentriertZeile
    PRINT AnzeigeText
    TextZentriertZeile = TextZentriertZeile + 1
'   ScreenUnLock
END SUB
'---------------------------------------------------------------
SUB TextOut_Centre(Ziel AS INTEGER, Font AS INTEGER, Text AS STRING, ZeigTxtPosX AS INTEGER, ZeigTxtPosY AS INTEGER, Farbe AS INTEGER)
   ' Dies Sub ersetzt einfach die Allegro Funktion TextOut_centre, da Allegro nicht eingebunden werden soll.
      STATIC AS INTEGER SikTextZentriertZeile
      IF ZeigTxtPosY = 0 THEN
         TEXT_Zentriert(Text, Farbe)
      ELSE
        SikTextZentriertZeile = TextZentriertZeile
        TextZentriertZeile = ZeigTxtPosY
        TEXT_Zentriert(Text, Farbe)
        TextZentriertZeile = SikTextZentriertZeile
      END IF
END SUB
'---------------------------------------------------------------
FUNCTION readkey () AS STRING
   DIM ReadKeyTaste AS STRING
   ReadKeyTaste=""
   DO WHILE LEN(ReadKeyTaste) = 0
      ReadKeyTaste=Inkey$
   LOOP
   readkey=ReadKeyTaste
END FUNCTION
'---------------------------------------------------------------
FUNCTION text_height (font AS INTEGER) AS INTEGER
   text_height = 8
END FUNCTION
'---------------------------------------------------------------
FUNCTION ZufallsZahlen (first AS INTEGER, last AS INTEGER) AS INTEGER
    FUNCTION = RND * (last - first) + first
END FUNCTION
'---------------------------------------------------------------
'---------------------------------------------------------------
SUB Protokoll(ProtTxt AS STRING)
     STATIC AS STRING DateiName
     DIM AS INTEGER DateiNr
     DateiName="fbmovprt.txt"
     DateiNr=FREEFILE
     OPEN DateiName FOR APPEND AS #DateiNr
        PRINT #DateiNr, ProtTxt
     CLOSE #DateiNr
END SUB
'---------------------------------------------------------------
SUB LcdFeld(LcdTxt AS STRING, LcdX AS INTEGER, LcdY AS INTEGER, LcdColor AS UINTEGER, LcdColorB AS UINTEGER, LcdFont AS INTEGER)
     'Zeigt ein LCD-Anzeigefeld auf dem Screen
     ' an Pos LcdX, LcdY (liob) Breite = Textbreite mal Fontbreite, Hoehe = Fonthoehe
     ' Textfarbe LcdColor AS RGB  Hintergrund LcdColorB AS RGB
     '
      LINE (LcdX-3-1, LcdY-1)-STEP(LEN(LcdTxt)*GibFontBreite(LcdFont)+3, GibFontHoehe(LcdFont)+1), RGB(0,0,0), B
      LINE (LcdX-3, LcdY)-STEP(LEN(LcdTxt)*GibFontBreite(LcdFont)+3+1, GibFontHoehe(LcdFont)+2), RGB(160,150,150), B
      LINE (LcdX-3, LcdY)-STEP(LEN(LcdTxt)*GibFontBreite(LcdFont)+3, GibFontHoehe(LcdFont)+1), RGB(64,0,0), BF
      PrintString(LcdTxt, LcdX-2, LcdY+1, LcdColor, LcdFont, 0)
END SUB
'-------------------------------------------------
SUB HolDesktopInfo
   SCREENINFO DesktopBreite, DesktopHoehe, DesktopFarbTiefe,,,,DesktopDriverName
   LOCATE 16,10
   PRINT STR(DesktopBreite) + "x" + STR(DesktopHoehe) + "x" + STR(DesktopFarbTiefe);
   PRINT " Grafik-Treiber:" + DesktopDriverName
END SUB
'-------------------------------------------------
SUB SetzDesktopWieInfo
   'falls das Prog unter Linux luft, vor Programmende wieder
   'auf ursprngliche Desktopeinstellungen zurck gehen,
   'im Test auf Knoppix behielt der Linuxdesktop die
   'Einstellungen, welche das Game zuletzt hatte :-(
   ScreenRes DesktopBreite, DesktopHoehe, DesktopFarbTiefe
END SUB