' *********************************************************
' * fenster.bas            Eastler            15.jan 2008 *
' * Upro zum Einden in andere Programme                   *
' * erstellt und zeigt "Fenster" (bmps) an                *
' *********************************************************
DECLARE FUNCTION Fenster (Was AS STRING, FenNr AS INTEGER, Para1 AS INTEGER, Para2 AS INTEGER, Para3 AS INTEGER, Para4 AS INTEGER, Txt AS STRING) AS STRING


FUNCTION Fenster (Was AS STRING, FenNr AS INTEGER, Para1 AS INTEGER, Para2 AS INTEGER, Para3 AS INTEGER, Para4 AS INTEGER, Txt AS STRING) AS STRING
   STATIC AS INTEGER Zaehler, Zaehler2, FensterZahl, AktFenster, BilderProFen, DateiBildBreit, DateiBildHoch
   STATIC AS INTEGER TafelBmpNr
   STATIC AS STRING Ruckgabe, FEDummy
   DIM AS INTEGER X1, X2, Y1, Y2, NextFreeFile, FEDummyBreit, FEDummyHoch, FEDummyX, FEDummyY
   DIM AS INTEGER HGFuellBereichX, HGFuellBereichY, HGFuellBereichBreit, HGFuellBereichHoch
   DIM AS INTEGER HGFuellBildZahlSenk, HGFuellBildZahlWaag, HGFuellMusterHoehe, HGFuellMusterBreite
   DIM AS UNSIGNED INTEGER FarbDkl, FarbHell
   BilderProFen = 20 'wie in Type.BildPtr() angelegt
   SELECT CASE UCASE(was)
      CASE "LOESCHEALLEBILDEREINESFENSTERS"
          'Ein Fenster wird nicht mehr gebraucht
          ' ACHTUNG, IM MOMENT BLEIBT DIE VERGEBENE FENSTERNUMMER VERBRAUCHT (waere sonst lueckenhafte Liste)
          IF Protokollieren=1 THEN Protokoll("   Fenster(): alle Bilder des Fensters " & STR(FenNr) & " werden geloescht")
          FOR Zaehler = 0 TO Fen(FenNr).BildZahl
             IF Fen(FenNr).BildPtr(Zaehler) <> 0 THEN IMAGEDESTROY( Fen(FenNr).BildPtr(Zaehler) )
          NEXT Zaehler
          IF Fen(FenNr).BmpPointer <> 0 THEN : IMAGEDESTROY(Fen(FenNr).BmpPointer) : Fen(FenNr).BmpPointer = 0 : END IF
      CASE "LOESCHEFENSTER"
          'Wird zwar schon aufgerufen, aber noch nix hier programmiert,
          'vorerst wird diese Lcke nicht fuer neue Fenster verwendet
          IF Protokollieren=1 THEN Protokoll("   Fenster(): Loesche Fenster " & STR(FenNr))
          FEDummy = Fenster ("LoescheAlleBilderEinesFensters", FenNr, 0, 0, 0, 0, "")
          IF FenNr = FensterZahl THEN
             'Falls das zu loeschende Fenster die hoechste Angelegte Fensternummer hat,
             'kann ja die Nr durch Reduzieren der Hochsten Nummer problemlos freigegeben werden
             FensterZahl = FensterZahl - 1
          END IF
      CASE "LOESCHALLEFENSTER"
          IF Protokollieren=1 THEN Protokoll("   Fenster(): Loesche ALLE Fenster (0-" & STR(FensterZahl) & ")")
          FOR Zaehler2 = 0 TO FensterZahl
             FOR Zaehler = 0 TO Fen(FenNr).BildZahl
                IF Fen(Zaehler2).BildPtr(Zaehler) <> 0 THEN IMAGEDESTROY( Fen(Zaehler2).BildPtr(Zaehler) )
             NEXT Zaehler
             IF Fen(Zaehler2).BmpPointer <> 0 THEN : IMAGEDESTROY(Fen(Zaehler2).BmpPointer) : Fen(Zaehler2).BmpPointer = 0 : END IF
          NEXT Zaehler2
          ERASE Fen
          FensterZahl=0
      CASE "ERSTELLEN"
          'Neues Fenster erstellen, jedoch nur, wenn im Array noch ne nummer frei ist!
          IF (AktFenster+1) <= (UBOUND(Fen)) THEN
             'Ok, Platz ist im Array noch
             AktFenster = FensterZahl + 1
             IF Protokollieren=1 THEN Protokoll("   Fenster(): Erstelle Fenster mit Nummer " & STR(AktFenster) & "  und Textuebergabe:" & Txt)
             'FEDummyhaft auf Pos 10.10 stellen
             Fen(AktFenster).Titel = Txt
             Fen(AktFenster).VerbergeTitel = 0
             Fen(AktFenster).XPos = 10
             Fen(AktFenster).YPos = 10
             'FEDummyhaft auf Groesse 10x10 setzen
             Fen(AktFenster).Breite = 10
             Fen(AktFenster).Hoehe  = 10
             'FEDummyHaft Farbe auf mittelgrau
             Fen(AktFenster).GrundFarbR = 128
             Fen(AktFenster).GrundFarbG = 128
             Fen(AktFenster).GrundFarbB = 128
             Fen(AktFenster).GrundFarbRGB = RGB(Fen(AktFenster).GrundFarbR, Fen(AktFenster).GrundFarbG, Fen(AktFenster).GrundFarbB)
             IF Fen(AktFenster).BmpPointer <> 0 THEN : IMAGEDESTROY(Fen(AktFenster).BmpPointer) : Fen(AktFenster).BmpPointer = 0 : END IF
             Fen(AktFenster).BmpPointer = IMAGECREATE(Fen(AktFenster).Breite,Fen(AktFenster).Hoehe,Fen(AktFenster).GrundFarbRGB)
             Fen(AktFenster).RahmFarbR = 50
             Fen(AktFenster).RahmFarbG = 50
             Fen(AktFenster).RahmFarbB = 50
             Fen(AktFenster).RahmFarbRGB = RGB(Fen(AktFenster).RahmFarbR, Fen(AktFenster).RahmFarbG, Fen(AktFenster).RahmFarbB)
             Fen(AktFenster).RahmBreit = 1
             Fen(AktFenster).RahmAbsVert = 8
             Fen(AktFenster).RahmAbsHor  = 10
             Fen(AktFenster).SchriftFarbR = 255
             Fen(AktFenster).SchriftFarbG = 255
             Fen(AktFenster).SchriftFarbB = 0
             Fen(AktFenster).SchriftFarbRGB = RGB(Fen(AktFenster).SchriftFarbR, Fen(AktFenster).SchriftFarbG, Fen(AktFenster).SchriftFarbB)
             Fen(AktFenster).FontNr = 0
             Fen(AktFenster).Sichtbar = 1
             Fen(AktFenster).BildZahl = 0
             Fen(AktFenster).InitFlag   = 1
             FensterZahl=AktFenster
             Ruckgabe = STR(AktFenster)
          ELSE
             CLS
             PRINT "Function Fenster(): Soll ein neues Fenster erstellen"
             PRINT "Maximale Fensterzahl (" & STR(UBOUND(Fen)) & ")aber bereits erreicht !"
             DO WHILE INKEY$=""
             LOOP
             Ruckgabe="Fehler!, Max Fensterzahl war schon erreicht!"
          END IF
      CASE "SETZTITEL"
             Fen(FenNr).Titel = LEFT(Txt,40)
             Fen(FenNr).VerbergeTitel = Para1
      CASE "SETZXY"
          Fen(FenNr).XPos = Para1
          Fen(FenNr).YPos = Para2
      CASE "SETZGRUNDFARBE"
             Fen(FenNr).GrundFarbR = Para1
             Fen(FenNr).GrundFarbG = Para2
             Fen(FenNr).GrundFarbB = Para3
             Fen(FenNr).GrundFarbRGB = RGB(Fen(FenNr).GrundFarbR, Fen(FenNr).GrundFarbG, Fen(FenNr).GrundFarbB)
      CASE "MALRECHTECK"
             LINE Fen(FenNr).BmpPointer, (Para1,Para2)-STEP(Para3,Para4), FEN(FenNr).NextAktionFarbe, BF
      CASE "FUELLRECHTECK"
             'Fllt im Fenster den Bereich (x=Para1, y=Para2)-STEP(breite=Para3,Hoehe=Para4)
             'mit dem Muster das in der Fenster-Bildmerkedatei Nr Val(TxT) steht.
             HGFuellBereichX     = Para1
             HGFuellBereichY     = Para2
             HGFuellBereichBreit = Para3+1
             HGFuellBereichHoch  = Para4+1
             HGFuellMusterBreite = Fen(FenNr).MBildBreite(VAL(Txt))
             HGFuellMusterHoehe  = Fen(FenNr).MBildHoehe(VAL(Txt))
             HGFuellBildZahlWaag = HGFuellBereichBreit \ HGFuellMusterBreite
             HGFuellBildZahlSenk = HGFuellBereichHoch  \ HGFuellMusterHoehe
             'Erst mal soweit ganze Fuellbilder in die Bitmap Passen, fllen
             FOR Zaehler = 0 TO HGFuellBildZahlSenk-1
                FOR Zaehler2 = 0 TO HGFuellBildZahlWaag-1
                   'QUELLE:  Fen(FenNr).BildPtr(Fen(FenNr).HgBmpBildNr)
                   'ZIEL:    Fen(FenNr).BmpPointer
                   PUT  Fen(FenNr).BmpPointer,  (HGFuellBereichX+Zaehler2*HGFuellMusterBreite, HGFuellBereichY+Zaehler*HGFuellMusterHoehe),  Fen(FenNr).BildPtr(VAL(Txt)), TRANS
                NEXT Zaehler2
             NEXT Zaehler
             'Jetzt an der Rechten Fensterkante runter die letzten Fllbilder in nicht voller Breite reinsetzen
             FEDummyBreit = HGFuellBereichBreit - HGFuellBildZahlWaag * HGFuellMusterBreite
             FEDummyX     = HGFuellBereichX + HGFuellBildZahlWaag * HGFuellMusterBreite
             FEDummyY     = HGFuellBereichY
             FOR Zaehler = 0 TO HGFuellBildZahlSenk-1
                PUT  Fen(FenNr).BmpPointer,  (FEDummyX, FEDummyY+Zaehler*HGFuellMusterHoehe) ,  Fen(FenNr).BildPtr(VAL(Txt)), (0,0)-STEP(FEDummyBreit-1, HGFuellMusterHoehe), TRANS
             NEXT Zaehler
             'Jetzt die Unterste Reihe, nicht volle Fllbildhoehe soweit volle Breite reinpat, reinsetzen
             FEDummyHoch  = HGFuellBereichHoch  - HGFuellBildZahlSenk * HGFuellMusterHoehe
             FEDummyX     = HGFuellBereichX
             FEDummyY     = HGFuellBereichY + HGFuellBildZahlSenk * HGFuellMusterHoehe
             FOR Zaehler = 0 TO HGFuellBildZahlWaag-1
                PUT  Fen(FenNr).BmpPointer,  (FEDummyX+Zaehler*HGFuellMusterBreite, FEDummyY) ,  Fen(FenNr).BildPtr(VAL(Txt)), (0,0)-STEP(HGFuellMusterBreite, FEDummyHoch), TRANS
             NEXT Zaehler
             'Und zum Schlu das Letzte Pattern ganz unten ganz rechts, geschmlert und geringere Hoehe
             FEDummyX     = HGFuellBereichX + HGFuellBildZahlWaag * HGFuellMusterBreite
             FEDummyY     = HGFuellBereichY + HGFuellBildZahlSenk * HGFuellMusterHoehe
             PUT  Fen(FenNr).BmpPointer,  (FEDummyX, FEDummyY) ,  Fen(FenNr).BildPtr(VAl(Txt)), (0,0)-STEP(FEDummyBreit, FEDummyHoch), TRANS
      CASE "FUELLDATEIMUSTER"
             'Para1 Bildbreite, Para2 Bildhoehe, Para3 -, Txt Dateiname des Bildes
             Fen(FenNr).HgBmpBildNr = VAL(Fenster("MerkeBild", FenNr, Para1, Para2, Para3, Para4, Txt))
             Fen(FenNr).HgBmpBildBreit = Fen(FenNr).MBildBreite(Fen(FenNr).HgBmpBildNr)
             Fen(FenNr).HgBmpBildHoch  = Fen(FenNr).MBildHoehe(Fen(FenNr).HgBmpBildNr)
             FEDummy = Fenster ("FuellRechtEck", FenNr, 0, 0, Fen(FenNr).Breite, Fen(FenNr).Hoehe, STR(Fen(FenNr).HgBmpBildNr))
      CASE "SETZRAHMENFARBE"
             Fen(FenNr).RahmFarbR = Para1
             Fen(FenNr).RahmFarbG = Para2
             Fen(FenNr).RahmFarbB = Para3
             Fen(FenNr).RahmFarbRGB = RGB(Fen(FenNr).RahmFarbR, Fen(FenNr).RahmFarbG, Fen(FenNr).RahmFarbB)
      CASE "SETZSCHRIFTFARBE"
             Fen(FenNr).SchriftFarbR = Para1
             Fen(FenNr).SchriftFarbG = Para2
             Fen(FenNr).SchriftFarbB = Para3
             Fen(FenNr).SchriftFarbRGB = RGB(Fen(FenNr).SchriftFarbR, Fen(FenNr).SchriftFarbG, Fen(FenNr).SchriftFarbB)
      CASE "SETZFONTNR"
             Fen(FenNr).FontNr = Para1
      CASE "SETZGROESSE"
             FEN(FenNr).Breite = Para1
             FEN(FenNr).Hoehe  = Para2
             IF Fen(FenNr).BmpPointer <> 0 THEN : IMAGEDESTROY(Fen(FenNr).BmpPointer) : Fen(FenNr).BmpPointer = 0 : END IF
             Fen(FenNr).BmpPointer = IMAGECREATE(Fen(FenNr).Breite,Fen(FenNr).Hoehe,Fen(FenNr).GrundFarbRGB)
      CASE "SETZRAHMENABSTAND"
             FEN(FenNr).RahmAbsHor   = Para1
             FEN(FenNr).RahmAbsVert  = Para2
      CASE "SETZRAHMENBREITE"
             'Rahmenbreite 0 = kein Rahmen
             FEN(FenNr).RahmBreit   = Para1
      CASE "SETZNEXTAKTIONFARBE"
             FEN(FenNr).NextAktionFarbe = RGB(Para1, Para2, Para3)
      CASE "ZEIGAN"
             'Blittet das (fertig erstelle) Fenster FenNr
             'falls Para1/Para2 ungleich 0  an Pos (X=Para1,Y=Para2) sonst an Pos Fen(FenNr).XPos/YPos
             'Falls Para 3 = 0 auf den Screen, falls Para3 <> 0 in die Bitmap des Fensters mit Nr Para3
             '------------------------------------------
             'festlegen, ob an Pos Para1/Para2 oder an Pos Fen(FenNr).XPos/YPos
             IF Para1 <> 0 THEN Fen(FenNr).XPos = Para1
             IF Para2 <> 0 THEN Fen(FenNr).YPos = Para2
             'und nun noch den Rahmen in Vars (X1,Y1)-(X2,Y2) festlegen
             X1 = Fen(FenNr).XPos + Fen(FenNr).RahmAbsHor-1
             X2 = Fen(FenNr).XPos + Fen(FenNr).Breite - Fen(FenNr).RahmAbsHor
             Y1 = Fen(FenNr).YPos + Fen(FenNr).RahmAbsVert-1
             Y2 = Fen(FenNr).YPos + Fen(FenNr).Hoehe - Fen(FenNr).RahmAbsVert
             'je nach Ziel(Para3) anzeigen
             IF Para3 = 0 THEN
                'Auf den Screen
                PUT (Fen(FenNr).XPos, Fen(FenNr).YPos), Fen(FenNr).BmpPointer, PSET
                IF Fen(FenNr).RahmBreit > 0 THEN LINE ( X1, Y1 ) - ( X2, Y2 ), Fen(FenNr).RahmFarbRGB, B
             ELSE
                'in die Bitmap des Fensters mit Nr Para3
                IF Para3 > 0 AND Para3 <= FensterZahl THEN
                   PUT Fen(Para3).BmpPointer, (Fen(FenNr).XPos, Fen(FenNr).YPos), Fen(FenNr).BmpPointer, PSET
                   IF Fen(FenNr).RahmBreit > 0 THEN LINE Fen(Para3).BmpPointer, ( X1, Y1 ) - ( X2, Y2 ), Fen(FenNr).RahmFarbRGB, B
                ELSE
                   PRINT "Fenster(): Soll das Fenster " & STR(FenNr) & "in Bitmap des Fensters " & STR(Para3) & " blitten, ZielfensterNr ist aber nicht OK"
                END IF
             END IF
             'Fensternummer als Titel anzeigen
             IF Fen(FenNr).VerbergeTitel <> 1 THEN
                PrintString(Fen(FenNr).Titel & STR(Fen(FenNr).BmpPointer), X1+15, Y1+(FontArray(1,0,0)), RGB(255,255,255), 1, 0)
             END IF
      CASE "SCHREIBTEXT"
             X1=Para1
             Y1=Para2
             PrintString(Txt, X1, Y1, Fen(FenNr).SchriftFarbRGB, Fen(FenNr).FontNr, Fen(FenNr).BmpPointer)
      CASE "SCHREIB3DTEXT
             'Para 3 = Kontrastwerd, also Farbwert der von allen 3 (rot,gruen,blau) jeweils abgezogen/hinzugezaehlt wird
             IF Para3 = 0 THEN Para3=20
             X1=Para1
             Y1=Para2
             FarbDkl  = RGB(Fen(FenNr).SchriftFarbR-Para3, Fen(FenNr).SchriftFarbG-Para3, Fen(FenNr).SchriftFarbB-Para3)
             FarbHell = RGB(Fen(FenNr).SchriftFarbR+Para3, Fen(FenNr).SchriftFarbG+Para3, Fen(FenNr).SchriftFarbB+Para3)
             Print3DString(TxT, X1, Y1, Fen(FenNr).SchriftFarbRGB, FarbDkl, FarbHell, Fen(FenNr).FontNr, Fen(FenNr).BmpPointer)
      CASE "SCHREIBGRAVTEXT
             X1=Para1
             Y1=Para2
             FarbHell = RGB(Fen(FenNr).SchriftFarbR-Para3, Fen(FenNr).SchriftFarbG-Para3, Fen(FenNr).SchriftFarbB-Para3)
             FarbDkl  = RGB(Fen(FenNr).SchriftFarbR+Para3, Fen(FenNr).SchriftFarbG+Para3, Fen(FenNr).SchriftFarbB+Para3)
             Print3DString(TxT, X1, Y1, Fen(FenNr).SchriftFarbRGB, FarbDkl, FarbHell, Fen(FenNr).FontNr, Fen(FenNr).BmpPointer)
      CASE "MERKEBILD"
             'Para1=Pixelbreite  Para2=Pixelhoehe  Txt=Dateiname, Rckgabe = "BildNr", aus Aufruf PruefeBildDatei steht in Static DateiBildBreit,DateiBildHoch die groe des Dateibildes
             IF Fen(FenNr).BildZahl < BilderProFen THEN
                'nur BilderProFen Bilder sind mglich
                 Fen(FenNr).BildZahl=Fen(FenNr).BildZahl+1
                'BMP-DATEINAME PRFEN
                IF Fenster("PruefeBildDatei", FenNr, Para1, Para2, Para3, Para4, Txt) = "BildDateiIstOK" THEN
                   IF Fen(FenNr).BildPtr(Fen(FenNr).BildZahl) <> 0 THEN : IMAGEDESTROY(Fen(FenNr).BildPtr(Fen(FenNr).BildZahl)) : Fen(FenNr).BildPtr(Fen(FenNr).BildZahl) = 0 : END IF
                   Fen(FenNr).BildPtr(Fen(FenNr).BildZahl) = IMAGECREATE(Fen(FenNr).MBildBreite(Fen(FenNr).BildZahl), Fen(FenNr).MBildHoehe(Fen(FenNr).BildZahl),0)
                   BLOAD(  Txt,   Fen(FenNr).BildPtr(Fen(FenNr).BildZahl)  )
                   Ruckgabe = STR$( Fen(FenNr).BildZahl )
                ELSE
                   Ruckgabe="-1"
                END IF
             ELSE
                Ruckgabe = "-1"
             END IF
      CASE "PRUEFEBILDDATEI" : ' fuer Interne Zwecke gedacht, immer wenn Bild einzulesen ist
                NextFreeFile = FREEFILE
                Open Txt FOR INPUT AS #NextFreeFile
                'existiert die Datei berhaupt? Falls ja, dann Breite und Hhe holen, ImgCreate und Einlesen
                IF LOF(NextFreeFile) > 0 THEN
                   Get #NextFreeFile, 19, Fen(FenNr).MBildBreite(Fen(FenNr).BildZahl)              'Breite aus der BMP-Datei auslesen
                   Get #NextFreeFile, 23, Fen(FenNr).MBildHoehe(Fen(FenNr).BildZahl)               'Hhe aus der BMP-Datei auslesen
'                   IF DateiBildBreit <> Para1 OR DateiBildHoch <> Para2 THEN
                      'Einzulesende Datei hat andere Bildgroesse als gewuenscht
'                      Locate 1,1
'                      PRINT "fenster(MerkeBild): soll Bild " & Txt & " laden, Datei hat abweichendes Bildformat!"
'                      PRINT "gewuenscht: " & STR(Para1) & " x " & STR(Para2) & "   Datei ist: " & STR(DateiBildBreit) & " x " & STR(DateiBildHoch)
'                   END IF
                   Ruckgabe = "BildDateiIstOK"
                ELSE
                   FEDummy = "Soll Bild aus der Datei " & Txt & " einlesen, Datei existiert jedoch nicht. Taste = weiter"
                   textout_centre(VarScreen, font, FEDummy, 30, 460, 255)
                   FEDummy=readkey()
                   IF Hintergrundbildpointer <> 0 THEN : IMAGEDESTROY(Hintergrundbildpointer) : Hintergrundbildpointer=0 : END IF
                   Ruckgabe="BildDateiNichtDa""
                END IF
                CLOSE #NextFreeFile
      CASE "SETZEBILDTRANSPARENT"
             'Mit MerkeBild eingelesenes Bild mit der MerkNummer Para3 an Pos Para1, Para2 in die Fensterbitmap schreiben
                 PUT Fen(FenNr).BmpPointer,  (Para1,    Para2) ,    Fen(FenNr).BildPtr(Para3), TRANS
      CASE ELSE
               FEDummy = "SelectCase in Fenster-Sub kennt folgende Aufgabe nicht: " & Was
               TEXT_Zentriert(FEDummy,255)
   END SELECT
   Fenster = Ruckgabe
END FUNCTION