' *********************************************************
' * objekte.bas            Eastler             1.Feb 2008 *
' * Upro zum Einden in andere Programme                   *
' * erstellt und zeigt "Objekte" (bmps) an                *
' * ---als Objekt sind feste Gegenstnde im Hintergrund   *
' *    gemeint, also Huser oder Bauminseln oder hnliches*
' *    Zeugs was so rumsteht, sich nie verndert,         *
' *    deshalb im Hintergrundbild verewigt ist,           *
' *    aber die Figuren drum rum laufen sollen und        *
' *    nicht darber                                      *
' *********************************************************

DECLARE FUNCTION Objekt(was AS STRING, ObjNr AS INTEGER, Para1 AS INTEGER, Para2 AS INTEGER, Para3 AS INTEGER, Para4 AS INTEGER, Txt AS STRING) AS STRING


TYPE ObjektType
   Name     AS STRING * 10
   Typ      AS STRING
   PosX     AS INTEGER
   PosY     AS INTEGER
   CenterX  AS INTEGER
   CenterY  AS INTEGER
   MittPktX AS INTEGER
   MittPktY AS INTEGER
   Breite   AS INTEGER
   Hoehe    AS INTEGER
   Radius   AS INTEGER
   BildPtr  AS ANY PTR
   sichtbar AS INTEGER
END TYPE

FUNCTION Objekt(was AS STRING, ObjNr AS INTEGER, Para1 AS INTEGER, Para2 AS INTEGER, Para3 AS INTEGER, Para4 AS INTEGER, Txt AS STRING) AS STRING
   STATIC Objekte(10) AS ObjektType
   STATIC AS STRING ObjDummy, Dateiname
   STATIC AS INTEGER FreieDateiNummer, DateiExistiert, AngelegteObjekte, ObjErstelltFlag
   DIM AS INTEGER HypoX, HypoY, Abstand1, ObjZaehler, PruefObj
   DIM AS STRING ObjRuckgabe, ObjTaste

   SELECT CASE UCASE(was)
      CASE "WERTEANZEIGEN"
            LOCATE 1,1
            PRINT "Objekt: " & Objekte(ObjNr).Name & " vom Typ " & Objekte(ObjNr).Typ
            PRINT "PosX/Y:" & STR(Objekte(ObjNr).PosX) & "/" & STR(Objekte(ObjNr).PosY) &  "Center X/Y:" & STR(Objekte(ObjNr).CenterX) & "/" & STR(Objekte(ObjNr).CenterY)
            PRINT "Breite/Hoehe: " & STR(Objekte(ObjNr).Breite) & "/" & STR(Objekte(ObjNr).Hoehe) & " Radius:" & STR(Objekte(ObjNr).Radius) & " BmpPtr:" & STR(Objekte(ObjNr).BildPtr)
      CASE "QUELLBILDERLOESCHEN"
            IF Protokollieren=1 THEN Protokoll("Objekt: Quellbilder der Objekte 1-" & STR(AngelegteObjekte)) & " werden geloescht "
            FOR ObjZaehler = 1 TO AngelegteObjekte
               IF Objekte(ObjZaehler).BildPtr>0 THEN
                  IMAGEDESTROY(Objekte(ObjZaehler).BildPtr)
               END IF
            NEXT ObjZaehler
      CASE "ERSTELLEN"
          IF ObjErstelltFlag=0 THEN
            IF Protokollieren=1 THEN Protokoll("Objekt: Erstelle Objekte")
            Objekte(1).Name = "Kirche"                          : ' Ist auch Dateiname
            Objekte(1).Name = "EasyH"
            Dateiname = "objekte" & VZT & Objekte(1).Name & ".bmp"
            ObjDummy = Objekt("LadeBild", 1, 0, 0, 0, 0, "")                : ' Damit werden auch Objekt(1).Breite und ...Hoehe inititalisiert
            Objekte(1).PosX =  10  :' X Pos in Bitmap Hintergrundbild mittig
            Objekte(1).PosY =  10  :' Y Pos in Bitmap Hintergrundbild 60 Pixel unten dran freilassen
            Objekte(1).CenterX = Objekte(1).PosX + (Objekte(1).Breite\2)
            Objekte(1).CenterY = Objekte(1).PosY + (Objekte(1).Hoehe \2)
            Objekte(1).Typ = "Kreis"
            Objekte(1).Radius = Objekte(1).Breite \2
            Objekte(1).sichtbar=1
'           ##########################
'           ##########################
            Objekte(2).Name = "HausA"                          : ' Ist auch Dateiname
            Dateiname = "objekte" & VZT & Objekte(2).Name & ".bmp"
            ObjDummy = Objekt("LadeBild", 2, 0, 0, 0, 0, "")                : ' Damit werden auch Objekt(1).Breite und ...Hoehe inititalisiert
            Objekte(2).PosX = (HgBildBreite-Objekte(2).Breite)-200  :' X Pos in Bitmap Hintergrundbild mittig
            Objekte(2).PosY =  HgBildHoehe-150  - Objekte(2).Hoehe  :' Y Pos in Bitmap Hintergrundbild 60 Pixel unten dran freilassen
            Objekte(2).CenterX = Objekte(2).PosX + (Objekte(2).Breite\2)
            Objekte(2).CenterY = Objekte(2).PosY + (Objekte(2).Hoehe \2)
            Objekte(2).Typ = "Kreis"
            Objekte(2).Radius = Objekte(2).Breite \2
            Objekte(2).sichtbar=1
'           ##########################
            Objekte(3).Name = "HausC"                          : ' Ist auch Dateiname
            Dateiname = "objekte" & VZT & Objekte(3).Name & ".bmp"
            ObjDummy = Objekt("LadeBild", 3, 0, 0, 0, 0, "")                : ' Damit werden auch Objekt(1).Breite und ...Hoehe inititalisiert
'            Objekte(3).PosX = (HgBildBreite-Objekte(3).Breite)-100  :' X Pos in Bitmap Hintergrundbild mittig
            Objekte(3).PosX = Objekte(2).PosX + 40  :' In Abhngigkeit von Haus A Haus C Positionieren
            Objekte(3).PosY = Objekte(2).PosY+Objekte(2).Hoehe*0.50*0.63  :' Y Pos in Bitmap Hintergrundbild 60 Pixel unten dran freilassen
            Objekte(3).CenterX = Objekte(3).PosX + (Objekte(3).Breite\2)
            Objekte(3).CenterY = Objekte(3).PosY + (Objekte(3).Hoehe \2)
            Objekte(3).Typ = "Kreis"
            Objekte(3).Radius = Objekte(3).Breite \2
            Objekte(3).sichtbar=1
'           ##########################
            Objekte(4).Name = "HausD"                          : ' Ist auch Dateiname
            Dateiname = "objekte" & VZT & Objekte(4).Name & ".bmp"
            ObjDummy = Objekt("LadeBild", 4, 0, 0, 0, 0, "")                : ' Damit werden auch Objekt(1).Breite und ...Hoehe inititalisiert
            Objekte(4).PosX = Objekte(3).PosX + 40  :' In Abhngigkeit von Haus A Haus C Positionieren
            Objekte(4).PosY = Objekte(3).PosY+Objekte(3).Hoehe*0.50*0.63  :' Y Pos in Bitmap Hintergrundbild 60 Pixel unten dran freilassen
            Objekte(4).CenterX = Objekte(4).PosX + (Objekte(4).Breite\2)
            Objekte(4).CenterY = Objekte(4).PosY + (Objekte(4).Hoehe \2)
            Objekte(4).Typ = "Kreis"
            Objekte(4).Radius = Objekte(4).Breite \2
            Objekte(4).sichtbar=1
'           ##########################
            Objekte(5).Name = "Kreisel1"                          : ' Ist auch Dateiname
            Dateiname = "objekte" & VZT & Objekte(5).Name & ".bmp"
            ObjDummy = Objekt("LadeBild", 5, 0, 0, 0, 0, "")                : ' Damit werden auch Objekt(1).Breite und ...Hoehe inititalisiert
            Objekte(5).PosX = Objekte(4).PosX + 40  :' In Abhngigkeit von Haus A Haus C Positionieren
            Objekte(5).PosY = Objekte(4).PosY+Objekte(4).Hoehe*0.50*0.63  :' Y Pos in Bitmap Hintergrundbild 60 Pixel unten dran freilassen
            Objekte(5).CenterX = Objekte(5).PosX + (Objekte(5).Breite\2)
            Objekte(5).CenterY = Objekte(5).PosY + (Objekte(5).Hoehe \2)
            Objekte(5).Typ = "Kreis"
            Objekte(5).Radius = Objekte(5).Breite \2
            Objekte(5).sichtbar=1
'           ##########################
            AngelegteObjekte = 4
            ObjErstelltFlag=1
         END IF
      CASE "LADEBILD"
                     FreieDateiNummer=FREEFILE
                     Open Dateiname FOR INPUT AS #FreieDateiNummer
                     IF LOF(FreieDateiNummer) > 0 THEN DateiExistiert = 1 ELSE DateiExistiert = 0
                        Get #FreieDateiNummer, 19, Objekte(ObjNr).Breite              'Breite aus der BMP-Datei auslesen
                        Get #FreieDateiNummer, 23, Objekte(ObjNr).Hoehe               'Hhe aus der BMP-Datei auslesen
                        IF Objekte(ObjNr).Breite<= 0 OR Objekte(ObjNr).Hoehe <= 0 THEN
                           PRINT "Objekt(): Soll fuer das Objekt Nr: " & STR(ObjNr) & " die Datei " & Dateiname & " einlesen"
                           PRINT "Bildformat in Datei = " & STR(Objekte(ObjNr).Breite) & " X " & STR(Objekte(ObjNr).Hoehe) & ")"
                           PRINT "Einer der Werte ist auf Null, kann damit nicht arbeiten!"
                           PRINT "Jegliche Taste = Abbruch"
                           DO WHILE INKEY="" : LOOP
                           SYSTEM
                        END IF
                     CLOSE #FreieDateiNummer
                     IF DateiExistiert = 1 THEN
                        IF Objekte(ObjNr).BildPtr <> 0 THEN IMAGEDESTROY( Objekte(ObjNr).BildPtr )
                        Objekte(ObjNr).BildPtr = IMAGECREATE(Objekte(ObjNr).Breite, Objekte(ObjNr).Hoehe)
                        BLOAD(Dateiname, Objekte(ObjNr).BildPtr)
                     ELSE
                        ObjDummy = "Objekt() Soll dem Objekt Nr " & STR$(ObjNr) & " die Bilddatei " & Dateiname & " zuordnen, Datei existiert jedoch nicht. Taste = weiter"
                        TEXT_Zentriert(ObjDummy, 255)
                        ObjDummy = readkey()
                     END IF
      CASE "INHINTERGRUNDEINBINDEN"
            FOR ObjZaehler = 1 TO AngelegteObjekte
               IF Objekte(ObjZaehler).sichtbar=1 THEN
                  IF Objekte(ObjZaehler).BildPtr <> 0 THEN
                     PUT  Hintergrundbildpointer,  (Objekte(ObjZaehler).PosX, Objekte(ObjZaehler).PosY) ,  Objekte(ObjZaehler).BildPtr, (0,0)-STEP(Objekte(ObjZaehler).Breite-1, Objekte(ObjZaehler).Hoehe-1), TRANS
                  ELSE
                     PRINT "Objekt() Soll das Objekt " & Objekte(ObjZaehler).Name & " mit Nr " & STR$(ObjZaehler) & " in Hintergrundbild einbinden, es ist jedoch keine Bilddatei eingelesen worden. Taste = weiter"
                  END IF
               END IF
            NEXT ObjZaehler
      CASE "ISTPOSIMOBJEKT"
            'Das Modul fr figurenbewegen fragt nach, ob die Position X=Para1 Y=para2  innerhalb eines
            'der angelegten Objekte liegt
            'Entfernung wird nach pytagoras errechnet, Abstand figurX-objektX = eine Kante, FigurY-objektY = andere Kante,
            'Diagonale der beiden KAnte = Entfernung
            'para1,2 = Mittelpunkt der Figur Posx,PosY    Para3 = ein Radiuswert aus der figurmitte,
            'der den Kontaktkreis errechnen lt
            ObjRuckgabe=""
            FOR ObjZaehler = 1 TO AngelegteObjekte
               PruefObj = ObjZaehler
               ObjRuckgabe=""
                HypoX = ABS(  Para1 - Objekte(PruefObj).CenterX )
                HypoY = ABS(  Para2 - Objekte(PruefObj).CenterY )
                Abstand1 = SQR(HypoX ^ 2 + HypoY ^ 2)
               IF Abstand1 <= Objekte(PruefObj).Radius+Para3 THEN
                  'Erst mal eine Fehlermeldung rein, in den If-Then danach wird ja normalerweise das richtige dann reingeschrieben
                  ObjRuckgabe="D" ' D fr drin - grins, falls nach 4xIf Then immer noch "D", dann nicht auswertbar drin
                  IF Para1 > Objekte(PruefObj).CenterX AND Para2 > Objekte(PruefObj).CenterY THEN : ObjRuckgabe="7" : ObjZaehler=AngelegteObjekte+1 : END IF
                  IF Para1 > Objekte(PruefObj).CenterX AND Para2 <= Objekte(PruefObj).CenterY THEN : ObjRuckgabe="1" : ObjZaehler=AngelegteObjekte+1 : END IF
                  IF Para1 <= Objekte(PruefObj).CenterX AND Para2 > Objekte(PruefObj).CenterY THEN : ObjRuckgabe="9" : ObjZaehler=AngelegteObjekte+1 : END IF
                  IF Para1 <= Objekte(PruefObj).CenterX AND Para2 <= Objekte(PruefObj).CenterY THEN : ObjRuckgabe="3" : ObjZaehler=AngelegteObjekte+1 : END IF
                  IF ZeigKollision=1 THEN
                     CIRCLE (Objekte(PruefObj).CenterX+LinkerLaufrand, Objekte(PruefObj).CenterY+ObererLaufrand), Objekte(PruefObj).Radius, RGB(255,255,0)
                     CIRCLE (Para1+LinkerLaufrand, Para2+ObererLaufrand), Para3, RGB(255,0,0)
                  END IF
               END IF
            NEXT ObjZaehler
      CASE "LOESCHEALLEOBJEKTE"
            IF Protokollieren=1 THEN Protokoll("Objekt: alle Objekte werden geloescht (1-" & STR(AngelegteObjekte))
            FOR ObjZaehler = 1 TO AngelegteObjekte
               IF Objekte(ObjZaehler).BildPtr>0 THEN
                  IMAGEDESTROY(Objekte(ObjZaehler).BildPtr)
               END IF
               ERASE Objekte
            NEXT ObjZaehler
            ObjErstelltFlag=0
      CASE ELSE
               TEXT_Zentriert("SelectCase in Objekt-Sub kennt folgende Aufgabe nicht: " & Was, 255)
   END SELECT
   Objekt = ObjRuckgabe
END FUNCTION