DECLARE FUNCTION Musik (was AS STRING, Song AS STRING, Para1 AS INTEGER) AS STRING
#ifndef __FB_DOS__
#include once "fmod.bi"
#endif

FUNCTION Musik (was AS STRING, Song AS STRING, Para1 AS INTEGER) AS STRING
   STATIC MusikInitFlag AS INTEGER
   STATIC LiedDateien(3) AS STRING
   STATIC mp3stream AS FSOUND_STREAM PTR
   DIM Zaehler AS INTEGER
   IF FmodEinbinden = "ja" THEN
      IF MusikInitFlag = 0 THEN
         IF( FSOUND_GetVersion() < FMOD_VERSION ) THEN
            CLS
            PRINT "FEHLER: Fuer die Ausgabe von Sounds oder Musik"
            PRINT "ist Fmod in der Version " & FMOD_VERSION & " oder hoeher notwendig!"
            PRINT "Schalte Sounds und Musik aus!"
            FmodOKFlag = -1
         ELSE
            IF( FSOUND_Init(44100, 32, 0) = 0 ) THEN
               PRINT "FEHLER: Kann Fmod nicht initialisieren!"
               PRINT "Schalte Sounds und Musik aus!"
               FmodOKFlag = -1
            ELSE
               'Fmod = gestartet und initialisiert
               FmodOKFlag = 1
            END IF
         END IF
         FSOUND_Stream_SetBufferSize( 50 )
         LiedDateien(1)="musik" & VZT & "Eas1_E.mp3"
         LiedDateien(2)="musik" & VZT & "Eas2_E.mp3"
         LiedDateien(3)="musik" & VZT & "Eas3_F.mp3"
         MusikInitFlag=1
      END IF
   END IF
   'Wenn Sound nicht ausgeschalten ist
   IF FmodOKFlag  > 0 THEN
      'je nach Aufruf Fmod steuern
      SELECT CASE UCASE(was)
         CASE "MUSIKABSPIELEN"
          IF FmodEinbinden = "ja" THEN
             'Nur, wenn nicht sowieso was gespielt wird
            IF (mp3stream = 0 OR FSOUND_Stream_GetPosition( mp3stream ) = 0 OR FSOUND_Stream_GetPosition( mp3stream ) >= FSOUND_Stream_GetLength( mp3stream )) THEN
               Zaehler = Rnd * (3 - 1) + 1 : 'Zufallszahl von 1 bis 3 ermitteln
               mp3stream = FSOUND_Stream_Open( LiedDateien(Zaehler), FSOUND_MPEGACCURATE, 0, 0 )
               IF( mp3stream <> 0 ) THEN
                  'nur abspielen, wenn auch was eingelesen werden konnte:
                  FSOUND_Stream_Play( FSOUND_FREE, mp3stream )
               END IF
            END IF
          END IF
         CASE "INTRO"
          IF FmodEinbinden = "ja" THEN
            'Nur, wenn nicht sowieso was gespielt wird
            IF (mp3stream = 0 OR FSOUND_Stream_GetPosition( mp3stream ) = 0 OR FSOUND_Stream_GetPosition( mp3stream ) >= FSOUND_Stream_GetLength( mp3stream )) THEN
               mp3stream = FSOUND_Stream_Open( "musik" & VZT & "Eas1_I.mp3", FSOUND_MPEGACCURATE, 0, 0 )
               IF( mp3stream <> 0 ) THEN
                  'nur abspielen, wenn auch was eingelesen werden konnte:
                  FSOUND_Stream_Play( FSOUND_FREE, mp3stream )
               END IF
            END IF
          END IF
         CASE "MUSIKBEENDEN"
          IF FmodEinbinden = "ja" THEN
            IF mp3stream <> 0 THEN FSOUND_Stream_Stop( mp3stream )
            IF mp3stream <> 0 THEN FSOUND_Stream_Close( mp3stream )
            mp3stream=0
          END IF
         CASE "FMODBEENDEN"
          IF FmodEinbinden = "ja" THEN
            IF MusikInitFlag = 1 THEN FSOUND_Close
            MusikInitFlag=0
            FmodOKFlag = -1
          END IF
      END SELECT
   END IF

   Musik = "OK"
END FUNCTION